// Beginning of interpolators from master to slave, or region1 to region0.

                        volScalarField& k = const_cast<volScalarField&>(mesh.lookupObject<volScalarField>("k.water"));
                        volScalarField& epsilon = const_cast<volScalarField&>(mesh.lookupObject<volScalarField>("epsilon.water"));
                        volScalarField& nutWater = const_cast<volScalarField&>(mesh.lookupObject<volScalarField>("nut.water"));
                        volScalarField& nutParticles = const_cast<volScalarField&>(mesh.lookupObject<volScalarField>("nut.particles"));
                        volScalarField& thetaParticles = const_cast<volScalarField&>(mesh.lookupObject<volScalarField>("Theta.particles"));

//                    //U1 interpolator    note:U1=U.particles
/*                       patchToPatchInterpolation interpolatorU1
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR //was CONTACT_SPHERE doesn't seem to make a difference
                        );

                        // interpolate from outlet to inlet
                        vectorField interpolatedInletU1 = interpolatorU1.faceInterpolate <vector>

                                                          (
                                U1.boundaryField()[master]
                                                          );

                        if(U1.boundaryField()[slave].type() != fixedValueFvPatchVectorField::typeName)
                                FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        U1.boundaryField()[slave] == interpolatedInletU1;
*/
                        //Info<< "U1.boundaryFieldMasterDomain1 = " << U1.boundaryField()[master] << endl;
                        //Info<< "U1.boundaryFieldSlaveDomain1 = " << U1.boundaryField()[slave] << endl;
                        //Info<< "inletU1InterpolDomain1 = " << interpolatedInletU1 << endl;

                        //U2 interpolator    note:U2=U.water
                        patchToPatchInterpolation interpolatorU2
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        vectorField interpolatedInletU2 = interpolatorU2.faceInterpolate <vector>

                                                          (
                                U2.boundaryField()[master]
                                                          );

                        if(U2.boundaryField()[slave].type() != fixedValueFvPatchVectorField::typeName)
                                FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        U2.boundaryField()[slave] == interpolatedInletU2;

                        //Info<< "inletU2InterpolDomain1 = " << interpolatedInletU2 << endl;

                        //p interpolator    note: needed to change scalar for vector
                        patchToPatchInterpolation interpolatorP
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletP = interpolatorP.faceInterpolate <scalar>

                                                         (
                                p.boundaryField()[master]
                                                         );

                        //if(p.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        //FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        p.boundaryField()[slave] == interpolatedInletP;

                        // Info<< "inletPInterpolDomain1 = " << interpolatedInletP << endl;

                        //p_rgh interpolator    note: needed to change scalar for vector
                        patchToPatchInterpolation interpolatorp_rgh
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletp_rgh = interpolatorp_rgh.faceInterpolate <scalar>

                                                             (
                                p_rgh.boundaryField()[master]
                                                             );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        p_rgh.boundaryField()[slave] == interpolatedInletp_rgh;

                        // Info<< "inletp_rghInterpolDomain1 = " << interpolatedInletp_rgh << endl;

                        //alpha1 interpolator    note: alpha1 is alpha.particles

                        patchToPatchInterpolation interpolatoralpha1
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletalpha1 = interpolatoralpha1.faceInterpolate <scalar>

                                                              (
                                alpha1.boundaryField()[master]
                                                              );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        alpha1.boundaryField()[slave] == interpolatedInletalpha1;

                        Info<< "inletalpha1InterpolDomain1 = " << alpha1.boundaryField()[master] << endl;

                        //alpha2 interpolator    note: alpha2 is alpha.water
                        patchToPatchInterpolation interpolatoralpha2
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletalpha2 = interpolatoralpha2.faceInterpolate <scalar>

                                                              (
                                alpha2.boundaryField()[master]
                                                              );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        alpha2.boundaryField()[slave] == interpolatedInletalpha2;

//            Info<< "alpha1 = " << alpha1 << endl;


                        //k interpolator    note:
                        patchToPatchInterpolation interpolatorK
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletK = interpolatorK.faceInterpolate <scalar>

                                                         (
                                k.boundaryField()[master]
                                                         );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        k.boundaryField()[slave] == interpolatedInletK;

                        //Info<< "inletKInterpolDomain1 = " << interpolatedInletK << endl;

                        //epsilon interpolator    note:
                        patchToPatchInterpolation interpolatorEpsilon
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletEpsilon = interpolatorEpsilon.faceInterpolate <scalar>

                                                               (
                                epsilon.boundaryField()[master]
                                                               );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        //epsilon.boundaryField()[slave] == interpolatedInletEpsilon;

                        //Info<< "inletEpsilonInterpolDomain1 = " << interpolatedInletEpsilon << endl;

                        //nut.water interpolator    note:
                        patchToPatchInterpolation interpolatorNutWater
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletNutWater = interpolatorNutWater.faceInterpolate <scalar>

                                                                (
                                nutWater.boundaryField()[master]
                                                                );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        nutWater.boundaryField()[slave] == interpolatedInletNutWater;

                        //Info<< "inletNutWInterpolDomain1 = " << interpolatedInletNutWater << endl;

                        //nut.particles interpolator    note:
                        patchToPatchInterpolation interpolatorNutParticles
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletNutParticles = interpolatorNutParticles.faceInterpolate <scalar>

                                                                    (
                                nutParticles.boundaryField()[master]
                                                                    );

                        // if(p_rgh.boundaryField()[slave].type() != fixedValueFvPatchScalarField::typeName)
                        // FatalError << "inlet patch should be fixedValue!" << exit(FatalError);

                        nutParticles.boundaryField()[slave] == interpolatedInletNutParticles;

                        // Info<< "inletNutPInterpolDomain1 = " << interpolatedInletNutParticles << endl;

                        //theta.particles interpolator    note:
                        patchToPatchInterpolation interpolatorThetaParticles
                        (
                                mesh.boundaryMesh()[master], // from patch
                                mesh.boundaryMesh()[slave], // to patch
                                intersection::FULL_RAY,
                                intersection::VECTOR
                        );

                        scalarField interpolatedInletThetaParticles = interpolatorThetaParticles.faceInterpolate <scalar>

                                                                      (
                                thetaParticles.boundaryField()[master]
                                                                      );

                        thetaParticles.boundaryField()[slave] == interpolatedInletThetaParticles;

                        // Info<< "inletNutPInterpolDomain1 = " << interpolatedInletNutParticles << endl;

//Info<< "alpha1slave = " << alpha1.boundaryField()[slave] << endl;
//Info<< "alpha1master = " << alpha1.boundaryField()[master] << endl;


//End of interpolators
